Subject: Re: a question about delayed ACK policy

From: Vern Paxson <[email-masked]>
Date: Fri, 12 Nov 1999 21:25:46 PST

> my question is that if out-of-order packet is received but it is next
> expected one, then the receiver should delay corresponding ACK ?

Here's the relevant part of RFC 2581, which boils down to "no, don't
delay the ack":

   Out-of-order data segments SHOULD be acknowledged immediately, in
   order to accelerate loss recovery.  To trigger the fast retransmit
   algorithm, the receiver SHOULD send an immediate duplicate ACK when
   it receives a data segment above a gap in the sequence space.  To
   provide feedback to senders recovering from losses, the receiver
   SHOULD send an immediate ACK when it receives a data segment that
   fills in all or part of a gap in the sequence space.

- Vern